SystemOrganization addCategory: #'Spec-Layout'!

Object subclass: #AbstractSpecLayoutAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!AbstractSpecLayoutAction commentStamp: '<historical>' prior: 0!
AbstractSpecLayoutAction is an abstract class representing a spec layout action.!

!AbstractSpecLayoutAction methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/18/2012 04:47'!
asSpecElements

	self subclassResponsibility ! !

!AbstractSpecLayoutAction methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 15:10'!
generateArguments

	! !

AbstractSpecLayoutAction subclass: #SpecLayoutSend
	instanceVariableNames: 'arguments selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutSend commentStamp: '<historical>' prior: 0!
A SpecLayoutSend is a spec layout action used when a selector is sent to the layout!

SpecLayoutSend subclass: #SpecLayoutAdd
	instanceVariableNames: 'fractions offsets subwidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAdd commentStamp: '<historical>' prior: 0!
A SpecLayoutAdd represents the action to add a subwidget into a spec layout!

!SpecLayoutAdd class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 04:42'!
subwidget: subwidget fractions: fractions offsets: offsets

	^ self new
		subwidget: subwidget 
		fractions: fractions 
		offsets: offsets;
		yourself! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
bottomFraction

	^ self fractions bottom! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
bottomFraction: aNumber

	^ self fractions: (self fractions bottom: aNumber)! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
bottomOffset

	^ self offsets bottom! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
bottomOffset: aNumber

	^ self offsets: (self offsets bottom: aNumber)! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
fractions
	^ fractions! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
fractions: anObject
	fractions := anObject! !

!SpecLayoutAdd methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/13/2012 03:16'!
generateArguments

	self arguments: {{subwidget .#layout:. {#FrameLayoutSpec. #fractions:offsets:. fractions. offsets}}}.! !

!SpecLayoutAdd methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/18/2012 04:50'!
initialize
	"Initialization code for SpecLayoutAdd"

	super initialize.
	
	self selector: #add:.

	fractions := nil.
	offsets := nil.
	subwidget := nil.! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:04'!
leftFraction

	^ self fractions left! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
leftFraction: aNumber

	^ self fractions: (self fractions left: aNumber)! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
leftOffset

	^ self offsets left! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
leftOffset: aNumber

	^ self offsets: (self offsets left: aNumber)! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
offsets
	^ offsets! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
offsets: anObject
	offsets := anObject! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:04'!
rightFraction

	^ self fractions right! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
rightFraction: aNumber

	^ self fractions: (self fractions right: aNumber)! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
rightOffset

	^ self offsets right! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:49'!
rightOffset: aNumber

	^ self offsets: (self offsets right: aNumber)! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
subwidget
	^ subwidget! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
subwidget: anObject
	subwidget := anObject! !

!SpecLayoutAdd methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 05:36'!
subwidget: aSpec fractions: frac offsets: off

	subwidget := aSpec isSymbol
				ifTrue: [{#model. aSpec}]
				ifFalse: [
					aSpec isCollection
						ifTrue: [
							aSpec isEmpty 
								ifTrue: [ "should raise an error" ]
								ifFalse: [ aSpec first == #model 
											ifTrue: [ aSpec ]
											ifFalse: [ {#model}, aSpec ]]]
						ifFalse: [ 
							"Not a symbol or a collection. We assume it's an object to add directly (like a morph by example)"
							aSpec ]].
	self fractions: frac.
	self offsets: off.
	
	self generateArguments! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
topFraction

	^ self fractions top! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
topFraction: aNumber

	^ self fractions: (self fractions top: aNumber )! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
topOffset

	^ self offsets top! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:23'!
topOffset: aNumber

	^ self offsets: (self offsets top: aNumber)! !

SpecLayoutAdd subclass: #SpecLayoutAddColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAddColumn commentStamp: '<historical>' prior: 0!
A SpecLayoutAddColumn is an action representing the addition of a column to a layout!

!SpecLayoutAddColumn class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 05:21'!
block: aBlock fractions: frac offsets: off

	^ self new
			block: aBlock 
			fractions: frac
			offsets: off;
			yourself! !

!SpecLayoutAddColumn methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 06:06'!
block: aBlock fractions: frac offsets: off
	| column |
	
	column := SpecColumnLayout composed.
	aBlock value: column.
	subwidget := column asArray.
	self fractions: frac.
	self offsets: off.
	
	self generateArguments! !

SpecLayoutAdd subclass: #SpecLayoutAddRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAddRow commentStamp: '<historical>' prior: 0!
A SpecLayoutAddRow is an action representing the addition of a row to a layout
!

!SpecLayoutAddRow class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 06:37'!
block: aBlock fractions: frac offsets: off

	^ self new
			block: aBlock 
			fractions: frac
			offsets: off;
			yourself! !

!SpecLayoutAddRow methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/18/2012 18:00'!
block: aBlock fractions: frac offsets: off
	| row |
	
	row := SpecRowLayout composed.
	aBlock value: row.
	subwidget := row asArray.
	self fractions: frac.
	self offsets: off.
	
	self generateArguments! !

SpecLayoutAdd subclass: #SpecSplitterHorizontal
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecSplitterHorizontal commentStamp: '<historical>' prior: 0!
A SpecSplitterHorizontal is a description of the addition of a horizontal splitter!

!SpecSplitterHorizontal class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/31/2012 15:11'!
commands: commands

	^ self new
		commands: commands;
		yourself! !

!SpecSplitterHorizontal methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:11'!
commands
	
	^ commands! !

!SpecSplitterHorizontal methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:11'!
commands: anObject
	
	commands := anObject! !

!SpecSplitterHorizontal methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 17:11'!
generateArguments
	| index |

	index := self commands identityIndexOf: self.

	self arguments: { index }! !

!SpecSplitterHorizontal methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/31/2012 16:10'!
initialize
	"Initialization code for SpecSplitterHorizontal"

	super initialize.

	selector := #newHSplitterAt:.
	fractions := 0@0 corner: 0@0.
	offsets := 0@0 corner: 0@1.
	commands := nil.! !

!SpecSplitterHorizontal methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:38'!
isSplitter

	^ true! !

SpecLayoutAdd subclass: #SpecSplitterVertical
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecSplitterVertical commentStamp: '<historical>' prior: 0!
A SpecSplitterVertical is the description of the addition of a vertical splitter!

!SpecSplitterVertical class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
commands: commands

	^ self new
		commands: commands;
		yourself! !

!SpecSplitterVertical methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
commands
	
	^ commands! !

!SpecSplitterVertical methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
commands: anObject
	
	commands := anObject! !

!SpecSplitterVertical methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
generateArguments
	| index |

	index := self commands identityIndexOf: self.

	self arguments: { index }! !

!SpecSplitterVertical methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/31/2012 16:09'!
initialize
	"Initialization code for SpecSplitterHorizontal"

	super initialize.

	selector := #newVSplitterAt:.
	fractions := 0@0 corner: 0@0.
	offsets := 0@0 corner: 1@0.
	commands := nil.! !

!SpecSplitterVertical methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
isSplitter

	^ true! !

SpecLayoutSend subclass: #SpecLayoutAddWithSpec
	instanceVariableNames: 'fractions offsets subwidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAddWithSpec commentStamp: '<historical>' prior: 0!
A SpecLayoutAddWithSpec is an action representing an add in the spec layout with a spec selector precised!

!SpecLayoutAddWithSpec class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 04:59'!
subwidget: subwidget spec: aSpecSelector fractions: fractions offsets: offsets

	^ self new
		subwidget: subwidget 
		spec: aSpecSelector 
		fractions: fractions 
		offsets: offsets;
		yourself! !

!SpecLayoutAddWithSpec methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/13/2012 03:16'!
generateArguments

	self arguments: {{subwidget .#layout:. {#FrameLayoutSpec. #fractions:offsets:. fractions. offsets}}}.! !

!SpecLayoutAddWithSpec methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 05:37'!
subwidget: sub spec: aSpecSelector fractions: frac offsets: off

	self subwidget: (sub isArray 
						ifTrue: [ #(model), sub , {aSpecSelector} ]
						ifFalse: [ {#model. sub . aSpecSelector } ]).
						
	self fractions: frac.
	self offsets: off.
	self generateArguments! !

!SpecLayoutSend class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
selector: selector arguments: arguments

	^ self new
		arguments: arguments;
		selector: selector;
		yourself! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
arguments
	
	^ arguments! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
arguments: anObject
	
	arguments := anObject! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/18/2012 05:07'!
asSpecElements

	^ {self selector.}, self arguments! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
bottomFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
bottomFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
bottomOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
bottomOffset: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:52'!
isSplitter

	^ false! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
leftFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
leftFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
leftOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
leftOffset: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
rightFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
rightFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
rightOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
rightOffset: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
selector
	
	^ selector! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
selector: anObject
	
	selector := anObject! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
topFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
topFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
topOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
topOffset: aNumber

	^ 0! !

Object subclass: #SpecLayout
	instanceVariableNames: 'type commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayout commentStamp: '<historical>' prior: 0!
A SpecPresenter is a object used to describe a user interface!

SpecLayout subclass: #SpecColumnLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecColumnLayout commentStamp: '<historical>' prior: 0!
A SpecColumnLayout is the layout used to specify a new column!

!SpecColumnLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 05:43'!
add: aSpec height: aNumber
	
	self add: aSpec origin: 0@0 corner: 1@1 offsetOrigin: 0@0 offsetCorner: 0@aNumber ! !

!SpecColumnLayout methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 7/31/2012 15:10'!
addSplitter

	self commands add: (SpecSplitterHorizontal commands: self commands)! !

!SpecColumnLayout methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 7/31/2012 18:08'!
asArray
	| size result currentOffset  numberOfProportionals currentProportional delta lastFractionIndex height |
	
	currentOffset := 0.
	currentProportional := 0.
	result := OrderedCollection new.
	result add: self type.
	size := self commands size.
	numberOfProportionals := 0.
	lastFractionIndex := 0.
	
	self commands do: [:e |
		e offsets = (0@0 corner: 0@0)
			ifTrue: [ numberOfProportionals := numberOfProportionals +1 ]].
	
	numberOfProportionals isZero
		ifTrue: [ delta := 0 ]
		ifFalse: [ delta := 1/numberOfProportionals ].
	
	self commands doWithIndex: [:e :idx || x0 x1 |
		e offsets = (0@0 corner: 0@0)
			ifTrue: [ "fractions"
				e fractions: (0@currentProportional corner: 1@(currentProportional +delta)).
				e offsets: (0@currentOffset corner: 0@0).
				currentOffset := 0.
				currentProportional := currentProportional +delta.
				lastFractionIndex := idx ]
			ifFalse: [ "offsets"
				height := e offsets height.
				x0 := e offsets left.
				x1 := e offsets right.
				idx = size
					ifTrue: [
						e fractions:  (0@1 corner: 1@1).
						e offsets: (x0@(height negated) corner: x1@0)]
					ifFalse: [
						e fractions: (0@currentProportional corner: 1@currentProportional).
						e offsets: (x0@currentOffset corner: x1@ (currentOffset + height)).
						currentOffset := (currentOffset + height) ]]].
			
	(lastFractionIndex > 0 and: [ lastFractionIndex < size ])
		ifTrue: [ | index ante x0 x1 y0 y1 |
			index := size-1.
			[ index > lastFractionIndex ] whileTrue: [ | myHeight |
				ante := self commands at: index.
				index := index -1.
				x0 := ante leftOffset.
				y0 := ante topOffset.
				x1 := ante rightOffset.
				y1 := ante bottomOffset.
				myHeight := y1-y0.
				ante offsets: (x0@((height+myHeight) negated) corner: x1@(height negated)).
				height := height+myHeight ].
			self assert: (index = lastFractionIndex).
			ante := self commands at: index.
			x0 := ante leftOffset.
			y0 := ante topOffset.
			x1 := ante rightOffset.
			y1 := ante bottomOffset.
			ante offsets: (x0@y0 corner: x1@(height negated)) ].		
			
	(self commands reject: [:e | e isSplitter ]) do: [:e |
		| left right bottom top windowBorderWidth |
		windowBorderWidth := self class windowBorderWidth.
		left := e leftOffset ifNil: [0].
		right := e rightOffset ifNil: [0].

		bottom := e bottomOffset ifNil: [0].
		top := e topOffset ifNil: [0].
		
		e rightFraction = 1 ifTrue: [ 
			right isZero 
				ifTrue: [ e rightOffset: windowBorderWidth negated ]
				ifFalse: [ e rightOffset: right - ProportionalSplitterMorph splitterWidth ]].
		e leftFraction = 0
			ifTrue: [ 
				left isZero 
					ifTrue: [ e leftOffset: windowBorderWidth ]
					ifFalse: [ e leftOffset: left+ ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e leftFraction = 1 ifFalse: [
						e leftOffset: left + ProportionalSplitterMorph splitterWidth]].

		e bottomFraction = 1 ifTrue: [ 
			bottom isZero
				ifTrue: [ e bottomOffset: windowBorderWidth negated ]
				ifFalse: [ e bottomOffset: bottom - ProportionalSplitterMorph splitterWidth ]].
		e topFraction = 0
			ifTrue: [ 
				top isZero 
					ifTrue: [ e topOffset: windowBorderWidth ]
					ifFalse: [ e topOffset: top + ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e topFraction = 1 ifFalse: [
						e topOffset: top + ProportionalSplitterMorph splitterWidth]].
		
		e generateArguments.
		e asSpecElements do: [:el |
			result add: el ]].
	
	(self commands select: [:e | e isSplitter ]) do: [:e |
		e generateArguments.
			e asSpecElements do: [:el |
				result add: el ]].
		
	result add: #checkSplitters.
	
	^ result asArray! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:44'!
abstract

	^self new 
		type: #AbstractSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:44'!
button

	^self new
		type: #ButtonSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:44'!
checkbox

	^self new 
		type: #CheckboxSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
composed

	^self new
		type: #ComposableSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/12/2012 18:57'!
dialogWindow

	^self new 
		type: #DialogWindowSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
droplist

	^self new 
		type: #DropListSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
iconlist

	^self new 
		type: #IconListSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
label

	^self new
		type: #LabelSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
list

	^self new 
		type: #List;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
multicolumnlist

	^self new 
		type: #MultiColumnListSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
raw

	^self new 
		type: #RawSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/12/2012 18:57'!
slider

	^self new 
		type: #SliderSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
text

	^self new 
		type: #TextSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
textfield 

	^self new 
		type: #TextFieldSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
tree

	^self new 
		type: #TreeSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/12/2012 18:57'!
window

	^self new 
		type: #WindowSpec;
		yourself! !

!SpecLayout class methodsFor: 'constants' stamp: 'BenjaminVanRyseghem 7/18/2012 18:49'!
windowBorderWidth

	^ 0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: aSpec 
	
	self add: aSpec origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: aSpec origin: originPoint corner: cornerPoint 

	self add: aSpec origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: aSpec origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint
	
	commands add: (SpecLayoutAdd 
							subwidget: aSpec
							fractions: (originPoint corner: cornerPoint)
							offsets: (ooPoint corner: ocPoint)).! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: modelGetter withSpec: aSymbol 
	
	self add: modelGetter withSpec: aSymbol origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint 

	self add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint

	commands add: (SpecLayoutAddWithSpec 
						subwidget: modelGetter 
						spec: aSymbol 
						fractions: (originPoint corner: cornerPoint)
						offsets: (ooPoint corner: ocPoint)).! !

!SpecLayout methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 7/31/2012 14:46'!
asArray
	| result |
	
	result := OrderedCollection new.
	result add: self type.
				
	self commands do: [:e |
		e asSpecElements do: [:el |
			result add: el ]].
		
	^result asArray! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
commands
	^ commands! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
commands: anObject
	commands := anObject! !

!SpecLayout methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
initialize 
	super initialize.
	
	type := #ComposableSpec.
	self commands: OrderedCollection new.! !

!SpecLayout methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
isSpecLayout

	^ true! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newColumn: aBlock 
	
	self newColumn: aBlock origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newColumn: aBlock origin: originPoint corner: cornerPoint 

	self newColumn: aBlock origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newColumn: aBlock origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint
	
	commands add: (SpecLayoutAddColumn
							block: aBlock
							fractions: (originPoint corner: cornerPoint)
							offsets: (ooPoint corner: ocPoint)).! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 7/9/2012 13:40'!
newColumn: aBlock  width: aNumber
	
	self newColumn: aBlock  origin: 0@0 corner: 0@1 offsetOrigin: 0@0 offsetCorner: aNumber @0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newRow: aBlock 
	
	self newRow: aBlock origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 7/9/2012 17:05'!
newRow: aBlock height: aNumber
	
	self newRow: aBlock  origin: 0@0 corner: 1@0 offsetOrigin: 0@0 offsetCorner: 0@aNumber ! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newRow: aBlock origin: originPoint corner: cornerPoint 

	self newRow: aBlock origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newRow: aBlock origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint
	
	commands add: (SpecLayoutAddRow
							block: aBlock
							fractions: (originPoint corner: cornerPoint)
							offsets: (ooPoint corner: ocPoint)).! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
send: aSelector
	
	self send: aSelector withArguments: #()! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
send: aSelector withArguments: arguments


	self commands add: (SpecLayoutSend
							selector: aSelector
							arguments: arguments).! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
type
	^ type! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
type: anObject
	type := anObject! !

SpecLayout subclass: #SpecRowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecRowLayout commentStamp: '<historical>' prior: 0!
A SpecRowLayout isthe layout used to specify a new row!

!SpecRowLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:33'!
add: aSpec width: aNumber
	
	self add: aSpec origin: 0@0 corner: 1@1 offsetOrigin: 0@0 offsetCorner: aNumber @0! !

!SpecRowLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 7/31/2012 16:09'!
addSplitter

	self commands add: (SpecSplitterVertical commands: self commands)! !

!SpecRowLayout methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 7/31/2012 18:09'!
asArray
	| result currentOffset  numberOfProportionals currentProportional delta size lastFractionIndex width |
	
	currentOffset := 0.
	currentProportional := 0.
	result := OrderedCollection new.
	result add: self type.
	numberOfProportionals := 0.
	lastFractionIndex := 0.
	size := self commands size.
	
	self commands do: [:e |
		e offsets = (0@0 corner: 0@0)
			ifTrue: [ numberOfProportionals := numberOfProportionals +1 ]].
	
	numberOfProportionals isZero
		ifTrue: [ delta := 0 ]
		ifFalse: [ delta := 1/numberOfProportionals ].
	
	self commands doWithIndex: [:e :idx |
		e offsets = (0@0 corner: 0@0)
			ifTrue: [
				e fractions: (currentProportional@0 corner: (currentProportional +delta)@1).
				e offsets: (currentOffset@0 corner: 0@0).
				currentOffset := 0.
				currentProportional := currentProportional +delta.
				lastFractionIndex := idx ]
			ifFalse: [| y0 y1 |
				width := e offsets width.
				y0 := e offsets top.
				y1 := e offsets bottom.
				idx = size 
					ifTrue: [
						e fractions: (1@0 corner: 1@1).
						e offsets: ((width negated)@y0 corner: 0@y1)]
					ifFalse: [
						e fractions: (currentProportional@0 corner: currentProportional@1).
						e offsets: (currentOffset@y0 corner: (currentOffset + width)@y1).
						currentOffset := (currentOffset + width) ]]].
	
	(lastFractionIndex > 0 and: [ lastFractionIndex < size ])
		ifTrue: [ | index ante x0 x1 y0 y1 |
			index := size-1.
			[ index > lastFractionIndex ] whileTrue: [ | myWidth |
				ante := self commands at: index.
				index := index -1.
				x0 := ante offsets topLeft x.
				y0 := ante offsets topLeft y.
				x1 := ante offsets bottomRight x.
				y1 := ante offsets bottomRight y.
				myWidth := x1-x0.
				ante offsets: (((width+myWidth) negated)@y0 corner: (width negated)@y1).
				width := width+myWidth ].
			self assert: (index = lastFractionIndex).
			ante := self commands at: index.
			x0 := ante offsets topLeft x.
			y0 := ante offsets topLeft y.
			y1 := ante offsets bottomRight y.
			ante offsets: (x0@y0 corner: (width negated)@y1) ].		
			
	(self commands reject: [:e | e isSplitter ]) do: [:e |
		| left right bottom top windowBorderWidth |
		windowBorderWidth := self class windowBorderWidth.
		left := e leftOffset ifNil: [0].
		right := e rightOffset ifNil: [0].

		bottom := e bottomOffset ifNil: [0].
		top := e topOffset ifNil: [0].
		
		e rightFraction = 1 ifTrue: [ 
			right isZero 
				ifTrue: [ e rightOffset: windowBorderWidth negated ]
				ifFalse: [ e rightOffset: right - ProportionalSplitterMorph splitterWidth ]].
		e leftFraction = 0
			ifTrue: [ 
				left isZero 
					ifTrue: [ e leftOffset: windowBorderWidth ]
					ifFalse: [ e leftOffset: left+ ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e leftFraction = 1 ifFalse: [
						e leftOffset: left + ProportionalSplitterMorph splitterWidth]].

		e bottomFraction = 1 ifTrue: [ 
			bottom isZero
				ifTrue: [ e bottomOffset: windowBorderWidth negated ]
				ifFalse: [ e bottomOffset: bottom - ProportionalSplitterMorph splitterWidth ]].
		e topFraction = 0
			ifTrue: [ 
				top isZero 
					ifTrue: [ e topOffset: windowBorderWidth ]
					ifFalse: [ e topOffset: top + ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e topFraction = 1 ifFalse: [
						e topOffset: top + ProportionalSplitterMorph splitterWidth]].
		e generateArguments.
		e asSpecElements do: [:el |
			result add: el ]].
	
	(self commands select: [:e | e isSplitter ]) do: [:e |
		e generateArguments.
		e asSpecElements do: [:el |
			result add: el ]].
	
	result add: #checkSplitters.
	
	^ result asArray! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 18:08'!
checkSplitters
	| size |
	
	size := submorphs size.
	(self submorphsSatisfying: [:e | e isKindOf: ProportionalSplitterMorph ]) do: [:e || index idx |
		index := submorphs identityIndexOf: e.
		idx := index + 1.
		"above"
		[ idx <= size and: [ ((submorphs at: idx) isKindOf: ProportionalSplitterMorph) not ]] whileTrue: [
			e addLeftOrTop: (submorphs at: idx).
			idx := idx +1 ].
		
		idx := index - 1.
		
		"below"
		[ idx > 0 and: [ ((submorphs at: idx) isKindOf: ProportionalSplitterMorph) not ]] whileTrue: [
			e addRightOrBottom: (submorphs at: idx).
			idx := idx -1 ]]! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 15:47'!
newHSplitter

	^ ProportionalSplitterMorph new
			beSplitsTopAndBottom;
			setProperty: #model toValue: self.! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 18:05'!
newHSplitterAt: anIndex
	| above frame splitter index size |

	size := submorphs size.
	index := size - anIndex + 2.
	above := self submorphs at: index.
	frame := above layoutFrame.
	
	splitter := self newHSplitter.
	splitter 
		layoutFrame: (LayoutFrame
							fractions: ((frame leftFraction @ frame bottomFraction) corner: (frame rightFraction @ frame bottomFraction))
							offsets: (0@0 corner: 0@4)).
								
	self privateAddMorph: splitter atIndex: (size - anIndex + 2)! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 15:47'!
newVSplitter

	^ ProportionalSplitterMorph new
			setProperty: #model toValue: self.! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 18:05'!
newVSplitterAt: anIndex
	| left frame splitter index size |

	size := submorphs size.
	index := size - anIndex + 2.
	left := self submorphs at: index.
	frame := left layoutFrame.
	
	splitter := self newVSplitter.
	splitter 
		layoutFrame: (LayoutFrame
							fractions: ((frame rightFraction @ frame topFraction) corner: (frame rightFraction @ frame bottomFraction))
							offsets: (0@0 corner: 4@0)).

	self privateAddMorph: splitter atIndex: (size - anIndex + 2)! !
